Index: uspace/lib/draw/drawctx.h
===================================================================
--- uspace/lib/draw/drawctx.h	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
+++ uspace/lib/draw/drawctx.h	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -0,0 +1,85 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef DRAW_DRAWCTX_H_
+#define DRAW_DRAWCTX_H_
+
+#include <sys/types.h>
+#include <bool.h>
+
+#include <compose.h>
+
+#include "surface.h"
+#include "source.h"
+#include "path.h"
+#include "font.h"
+
+typedef struct drawctx {
+	link_t link;
+	list_t list;
+
+	surface_t *surface;
+	compose_t compose;
+	surface_t *mask;
+	source_t *source;
+	font_t *font;
+
+	bool shall_clip;
+	sysarg_t clip_x;
+	sysarg_t clip_y;
+	sysarg_t clip_width;
+	sysarg_t clip_height;
+} drawctx_t;
+
+extern void drawctx_init(drawctx_t *, surface_t *);
+
+extern void drawctx_save(drawctx_t *);
+extern void drawctx_restore(drawctx_t *);
+
+extern void drawctx_set_compose(drawctx_t *, compose_t);
+extern void drawctx_set_clip(drawctx_t *, sysarg_t, sysarg_t, sysarg_t, sysarg_t);
+extern void drawctx_set_mask(drawctx_t *, surface_t *);
+extern void drawctx_set_source(drawctx_t *, source_t *);
+extern void drawctx_set_font(drawctx_t *, font_t *);
+
+extern void drawctx_transfer(drawctx_t *, sysarg_t, sysarg_t, sysarg_t, sysarg_t);
+extern void drawctx_stroke(drawctx_t *, path_t *);
+extern void drawctx_fill(drawctx_t *, path_t *);
+extern void drawctx_print(drawctx_t *, const char *, sysarg_t, sysarg_t);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/draw/font.c
===================================================================
--- uspace/lib/draw/font.c	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
+++ uspace/lib/draw/font.c	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -0,0 +1,169 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <assert.h>
+#include <malloc.h>
+
+#include "font.h"
+#include "font/embedded.h"
+#include "drawctx.h"
+
+void font_init(font_t *font, font_decoder_type_t decoder, char *path, uint16_t points)
+{
+	font->points = points;
+
+	switch (decoder) {
+	case FONT_DECODER_EMBEDDED:
+		font->decoder = &fd_embedded;
+		break;
+	default:
+		font->decoder = NULL;
+		break;
+	}
+
+	if (font->decoder) {
+		font->decoder->init(path, &font->glyph_count, &font->decoder_data);
+
+		if (font->glyph_count > 0) {
+			font->glyphs = (surface_t **) malloc(sizeof(surface_t *) * font->glyph_count);
+		} else {
+			font->glyphs = NULL;
+		}
+
+		if (font->glyphs) {
+			for (size_t i = 0; i < font->glyph_count; ++i) {
+				font->glyphs[i] = NULL;
+			}
+		} else {
+			font->glyph_count = 0;
+		}
+	} else {
+		font->glyph_count = 0;
+		font->glyphs = NULL;
+		font->decoder_data = NULL;
+	}
+}
+
+void font_release(font_t *font)
+{
+	if (font->glyphs) {
+		for (size_t i = 0; i < font->glyph_count; ++i) {
+			if (font->glyphs[i]) {
+				surface_destroy(font->glyphs[i]);
+			}
+		}
+		free(font->glyphs);
+	}
+	
+	if (font->decoder) {
+		font->decoder->release(font->decoder_data);
+	}
+}
+
+void font_get_box(font_t *font, char *text, sysarg_t *width, sysarg_t *height)
+{
+	assert(width);
+	assert(height);
+
+	(*width) = 0;
+	(*height) = 0;
+
+	if (!text) {
+		return;
+	}
+
+	while (*text) {
+		uint16_t glyph_idx = font->decoder->resolve(*text, font->decoder_data);
+		if (glyph_idx < font->glyph_count) {
+			if (!font->glyphs[glyph_idx]) {
+				font->glyphs[glyph_idx] =
+				    font->decoder->render(glyph_idx, font->points);
+			}
+
+			surface_t *glyph = font->glyphs[glyph_idx];
+			if (glyph) {
+				sysarg_t w;
+				sysarg_t h;
+				surface_get_resolution(glyph, &w, &h);
+				(*width) += w;
+				(*height) = (*height) < h ? h : (*height);
+			}
+		}
+		++text;
+	}
+}
+
+void font_draw_text(font_t *font, drawctx_t *context, source_t *source,
+    const char *text, sysarg_t x, sysarg_t y)
+{
+	assert(context);
+	assert(source);
+
+	drawctx_save(context);
+	drawctx_set_compose(context, compose_over);
+
+	while (*text) {
+		uint16_t glyph_idx = font->decoder->resolve(*text, font->decoder_data);
+		if (glyph_idx < font->glyph_count) {
+			if (!font->glyphs[glyph_idx]) {
+				font->glyphs[glyph_idx] =
+				    font->decoder->render(glyph_idx, font->points);
+			}
+
+			surface_t *glyph = font->glyphs[glyph_idx];
+			if (glyph) {
+				sysarg_t w;
+				sysarg_t h;
+				surface_get_resolution(glyph, &w, &h);
+
+				transform_t transform;
+				transform_identity(&transform);
+				transform_translate(&transform, x, y);
+				source_set_transform(source, transform);
+				source_set_mask(source, glyph, false);
+				drawctx_transfer(context, x, y, w, h);
+
+				x += w;
+			}
+		}
+		++text;
+	}
+
+	drawctx_restore(context);
+	source_set_mask(source, NULL, false);
+}
+
+/** @}
+ */
Index: uspace/lib/draw/font.h
===================================================================
--- uspace/lib/draw/font.h	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
+++ uspace/lib/draw/font.h	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -0,0 +1,76 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef DRAW_FONT_H_
+#define DRAW_FONT_H_
+
+#include <sys/types.h>
+
+#include "surface.h"
+#include "source.h"
+
+struct drawctx;
+typedef struct drawctx drawctx_t;
+
+typedef enum {
+	FONT_DECODER_EMBEDDED
+} font_decoder_type_t;
+
+typedef struct {
+	void (*init)(char *, uint16_t *, void **);
+	uint16_t (*resolve)(const wchar_t, void *);
+	surface_t *(*render)(uint16_t, uint16_t);
+	void (*release)(void *);
+} font_decoder_t;
+
+typedef struct font {
+	uint16_t points;
+	uint16_t glyph_count;
+	surface_t **glyphs;
+	font_decoder_t *decoder;
+	void *decoder_data;
+} font_t;
+
+extern void font_init(font_t *, font_decoder_type_t, char *, uint16_t);
+extern void font_release(font_t *);
+
+extern void font_get_box(font_t *, char *, sysarg_t *, sysarg_t *);
+extern void font_draw_text(font_t *, drawctx_t *, source_t *, const char *,
+    sysarg_t, sysarg_t);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/draw/font/embedded.c
===================================================================
--- uspace/lib/draw/font/embedded.c	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
+++ uspace/lib/draw/font/embedded.c	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -0,0 +1,118 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <assert.h>
+#include <sys/types.h>
+#include <malloc.h>
+
+#include "../gfx/font-8x16.h"
+#include "embedded.h"
+#include "../drawctx.h"
+
+static void fde_init(char *path, uint16_t *glyph_count, void **data)
+{
+	assert(glyph_count);
+	assert(data);
+
+	(*glyph_count) = FONT_GLYPHS;
+	(*data) = NULL;
+}
+
+static uint16_t fde_resolve(const wchar_t chr, void *data)
+{
+	return fb_font_glyph(chr);
+}
+
+static surface_t *fde_render(uint16_t glyph, uint16_t points)
+{
+	surface_t *template = surface_create(FONT_WIDTH, FONT_SCANLINES, NULL, 0);
+	if (!template) {
+		return NULL;
+	}
+	for (unsigned int y = 0; y < FONT_SCANLINES; ++y) {
+		for (unsigned int x = 0; x < FONT_WIDTH; ++x) {
+			pixel_t p = (fb_font[glyph][y] & (1 << (7 - x))) ? 
+			    PIXEL(255, 0, 0, 0) : PIXEL(0, 0, 0, 0);
+			surface_put_pixel(template, x, y, p);
+		}
+	}
+
+	source_t source;
+	source_init(&source);
+	source_set_texture(&source, template, false);
+
+	transform_t transform;
+	transform_identity(&transform);
+	if (points != FONT_SCANLINES) {
+		double ratio = ((double) points) / ((double) FONT_SCANLINES);
+		transform_scale(&transform, ratio, ratio);
+		source_set_transform(&source, transform);
+	}
+
+	double width = FONT_WIDTH;
+	double height = FONT_SCANLINES;
+	transform_apply_linear(&transform, &width, &height);
+	surface_t *result =
+	    surface_create((sysarg_t) (width + 0.5), (sysarg_t) (height + 0.5), NULL, 0);
+	if (!result) {
+		surface_destroy(template);
+		return NULL;
+	}
+
+	drawctx_t context;
+	drawctx_init(&context, result);
+	drawctx_set_source(&context, &source);
+	drawctx_transfer(&context, 0, 0,
+	    (sysarg_t) (width + 0.5), (sysarg_t) (height + 0.5));
+
+	surface_destroy(template);
+
+	return result;
+}
+
+static void fde_release(void *data)
+{
+	/* no-op */
+}
+
+font_decoder_t fd_embedded = {
+	.init = fde_init,
+	.resolve = fde_resolve,
+	.render = fde_render,
+	.release = fde_release
+};
+
+/** @}
+ */
Index: uspace/lib/draw/font/embedded.h
===================================================================
--- uspace/lib/draw/font/embedded.h	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
+++ uspace/lib/draw/font/embedded.h	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef DRAW_FONT_EMBEDDED_H_
+#define DRAW_FONT_EMBEDDED_H_
+
+#include "../font.h"
+
+extern font_decoder_t fd_embedded;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/draw/gfx/cursor-11x18.c
===================================================================
--- uspace/lib/draw/gfx/cursor-11x18.c	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
+++ uspace/lib/draw/gfx/cursor-11x18.c	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -0,0 +1,51 @@
+/*
+ * Copyright (c) 2008 Martin Decky
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup genarch
+ * @{
+ */
+/** @file
+ */
+
+#include "cursor-11x18.h"
+
+uint8_t cursor_texture[] = {
+	0x01, 0x00, 0x03, 0x00, 0x05, 0x00, 0x09, 0x00, 0x11, 0x00, 0x21, 0x00,
+	0x41, 0x00, 0x81, 0x00, 0x01, 0x01, 0x01, 0x02, 0x01, 0x04, 0x01, 0x03,
+	0x81, 0x00, 0x89, 0x00, 0x15, 0x01, 0x23, 0x01, 0x21, 0x01, 0xc0, 0x00
+};
+
+uint8_t cursor_mask[] = {
+	0x01, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0f, 0x00, 0x1f, 0x00, 0x3f, 0x00,
+	0x7f, 0x00, 0xff, 0x00, 0xff, 0x01, 0xff, 0x03, 0xff, 0x07, 0xff, 0x03,
+	0xff, 0x00, 0xff, 0x00, 0xf7, 0x01, 0xe3, 0x01, 0xe1, 0x01, 0xc0, 0x00
+};
+
+/** @}
+ */
Index: uspace/lib/draw/gfx/cursor-11x18.h
===================================================================
--- uspace/lib/draw/gfx/cursor-11x18.h	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
+++ uspace/lib/draw/gfx/cursor-11x18.h	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -0,0 +1,50 @@
+/*
+ * Copyright (c) 2008 Martin Decky
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup genarch
+ * @{
+ */
+/** @file
+ */
+
+#ifndef CURSOR_11X18_H_
+#define CURSOR_11X18_H_
+
+#include <sys/types.h>
+
+#define CURSOR_WIDTH   11
+#define CURSOR_HEIGHT  18
+
+extern uint8_t cursor_texture[];
+extern uint8_t cursor_mask[];
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/draw/gfx/font-8x16.h
===================================================================
--- uspace/lib/draw/gfx/font-8x16.h	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
+++ uspace/lib/draw/gfx/font-8x16.h	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -0,0 +1,50 @@
+/*
+ * Copyright (c) 2005 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup genarch
+ * @{
+ */
+/** @file
+ */
+
+#ifndef FONT_8X16_H_
+#define FONT_8X16_H_
+
+#include <sys/types.h>
+
+#define FONT_GLYPHS     2899
+#define FONT_WIDTH      8
+#define FONT_SCANLINES  16
+
+extern uint16_t fb_font_glyph(const wchar_t);
+extern uint8_t fb_font[FONT_GLYPHS][FONT_SCANLINES];
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/draw/path.c
===================================================================
--- uspace/lib/draw/path.c	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
+++ uspace/lib/draw/path.c	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -0,0 +1,114 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <assert.h>
+#include <bool.h>
+#include <malloc.h>
+
+#include "path.h"
+
+struct path {
+	list_t list;
+	double cur_x;
+	double cur_y;
+};
+
+void path_init(path_t *path)
+{
+	list_initialize(&path->list);
+	path->cur_x = 0;
+	path->cur_y = 0;
+}
+
+void path_clear(path_t *path)
+{
+	while (!list_empty(&path->list)) {
+		path_step_t *step = (path_step_t *) list_last(&path->list);
+		list_remove(&step->link);
+		free(step);
+	}
+	path->cur_x = 0;
+	path->cur_y = 0;
+}
+
+void path_get_cursor(path_t *path, double *x, double *y)
+{
+	assert(x);
+	assert(y);
+
+	*x = path->cur_x;
+	*y = path->cur_y;
+}
+
+void path_move_to(path_t *path, double dx, double dy)
+{
+	path_step_t *step = (path_step_t *) malloc(sizeof(path_step_t));
+	if (step) {
+		path->cur_x += dx;
+		path->cur_y += dy;
+		link_initialize(&step->link);
+		step->type = PATH_STEP_MOVETO;
+		step->to_x = path->cur_x;
+		step->to_y = path->cur_y;
+		list_append(&step->link, &path->list);
+		
+	}
+}
+
+void path_line_to(path_t *path, double dx, double dy)
+{
+	path_step_t *step = (path_step_t *) malloc(sizeof(path_step_t));
+	if (step) {
+		path->cur_x += dx;
+		path->cur_y += dy;
+		link_initialize(&step->link);
+		step->type = PATH_STEP_LINETO;
+		step->to_x = path->cur_x;
+		step->to_y = path->cur_y;
+		list_append(&step->link, &path->list);
+	}
+}
+
+void path_rectangle(path_t *path, double x, double y, double width, double height)
+{
+	path_move_to(path, x, y);
+	path_line_to(path, width, 0);
+	path_line_to(path, 0, height);
+	path_line_to(path, -width, 0);
+	path_line_to(path, 0, -height);
+}
+
+/** @}
+ */
Index: uspace/lib/draw/path.h
===================================================================
--- uspace/lib/draw/path.h	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
+++ uspace/lib/draw/path.h	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -0,0 +1,69 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef DRAW_PATH_H_
+#define DRAW_PATH_H_
+
+#include <adt/list.h>
+
+typedef enum {
+	PATH_STEP_MOVETO,
+	PATH_STEP_LINETO
+} path_step_type_t;
+
+typedef struct {
+	link_t link;
+	path_step_type_t type;
+	double to_x;
+	double to_y;
+} path_step_t;
+
+struct path;
+typedef struct path path_t;
+
+extern void path_init(path_t *);
+extern void path_clear(path_t *);
+
+extern void path_get_cursor(path_t *, double *, double *);
+
+extern void path_move_to(path_t *, double, double);
+extern void path_line_to(path_t *, double, double);
+
+extern void path_rectangle(path_t *, double, double, double, double);
+
+#endif
+
+/** @}
+ */
